qspipsu: xqspipsu_generic_flash_interrupt_example.c File Reference

| qspipsu Xilinx SDK Drivers API Documentation

- Overview
- Data Structures
- APIs
- File List
- Examples

Functions
xqspipsu_generic_flash_interrupt_example.c File Reference

## Overview

This file contains a design example using the QSPIPSU driver (XQspiPsu) with a serial Flash device greater than or equal to 128Mb.

The example writes to flash and reads it back in DMA mode. This examples runs with GENFIFO Manual start. It runs in interrupt mode. This example illustrates single, parallel and stacked modes. Both the flash devices have to be of the same make and size. The hardware which this example runs on, must have a serial Flash (Micron N25Q or Spansion S25FL) for it to run. In order to test in single, parallel or stacked flash configurations the necessary HW must be present and QSPI_MODE (also reflected in ConnectionMode in the instance) has to be in sync with HW flash configuration being tested.

This example has been tested with the Micron Serial Flash (N25Q512) and ISSI Serial Flash parts of IS25WP and IS25LP series flashes in single and parallel modes using A53 and R5 processors.

Note

None.

     MODIFICATION HISTORY:

     Ver   Who Date     Changes

     1.0   hk  08/21/14 First release
           sk  06/17/15 Used Tx/Rx flags for Transmitting/Receiving.
                    sk  11/23/15 Added Support for Macronix 1Gb part.
           ms  04/05/17 Modified Comment lines in functions to
                        recognize it as documentation block for doxygen
                        generation.
     1.1    tjs     06/16/17 Added support for IS25LP256D flash part (PR-4650)
     1.5    tjs 09/15/17 Replaced #ifdef COMMENTS to #if USE_FOUR_BYTE (CR-984966)
     1.6    tjs 10/16/17 #ifdef COMMENT replaced with the flow similar to
                        u-boot and linux for accessing flash parts with
                        size more then 16MB (CR-984966)
     1.7   tjs 11/16/17 Removed the unsupported 4 Byte write and sector erase
                        commands.
     1.7    tjs     12/01/17 Added support for MT25QL02G Flash from Micron. CR-990642
     1.7    tjs 12/19/17 Added support for S25FL064L from Spansion. CR-990724
     1.7    tjs 01/11/18 Added support for MX66L1G45G flash from Macronix CR-992367
     1.7    tjs 26/03/18 In dual parallel mode enable both CS when issuing Write
                                     enable command. CR-998478
     1.8    tjs 05/02/18 Added support for IS25LP064 and IS25WP064.
     1.8    tjs 16/07/18 Added support for the low density ISSI flash parts.
     1.9    akm 02/27/19 Added support for IS25LP128, IS25WP128, IS25LP256,
                         IS25WP256, IS25LP512, IS25WP512 Flash Devices
     1.9   akm 04/03/19 Fixed data alignment warnings on IAR compiler.
     1.10   akm 09/05/19 Added Multi Die Erase and Muti Die Read support.

## Functions
int | QspiPsuInterruptFlashExample (XScuGic *IntcInstancePtr, XQspiPsu *QspiPsuInstancePtr, u16 QspiPsuDeviceId, u16 QspiPsuIntrId)
| The purpose of this function is to illustrate how to use the XQspiPsu device driver in single, parallel and stacked modes using flash devices greater than or equal to 128Mb. More...
int | FlashReadID (XQspiPsu *QspiPsuPtr)
| Reads the flash ID and identifies the flash in FCT table. More...
int | FlashErase (XQspiPsu *QspiPsuPtr, u32 Address, u32 ByteCount, u8 *WriteBfrPtr)
| This function erases the sectors in the serial Flash connected to the QSPIPSU interface. More...
int | FlashWrite (XQspiPsu *QspiPsuPtr, u32 Address, u32 ByteCount, u8 Command, u8 *WriteBfrPtr)
| This function writes to the serial Flash connected to the QSPIPSU interface. More...
int | FlashRead (XQspiPsu *QspiPsuPtr, u32 Address, u32 ByteCount, u8 Command, u8 *WriteBfrPtr, u8 *ReadBfrPtr)
| This function performs a read. More...
int | MultiDieRead (XQspiPsu *QspiPsuPtr, u32 Address, u32 ByteCount, u8 Command, u8 *WriteBfrPtr, u8 *ReadBfrPtr)
| This function performs a read operation for multi die flash devices. More...
u32 | GetRealAddr (XQspiPsu *QspiPsuPtr, u32 Address)
| This functions translates the address based on the type of interconnection. More...
int | BulkErase (XQspiPsu *QspiPsuPtr, u8 *WriteBfrPtr)
| This functions performs a bulk erase operation when the flash device has a single die. More...
int | DieErase (XQspiPsu *QspiPsuPtr, u8 *WriteBfrPtr)
| This functions performs a die erase operation on all the die in the flash device. More...
void | QspiPsuHandler (void *CallBackRef, u32 StatusEvent, unsigned int ByteCount)
| Callback handler. More...
int | FlashEnterExit4BAddMode (XQspiPsu *QspiPsuPtr, unsigned int Enable)
| This API enters the flash device into 4 bytes addressing mode. More...
int | FlashEnableQuadMode (XQspiPsu *QspiPsuPtr)
| This API enables Quad mode for the flash parts which require to enable quad mode before using Quad commands. More...
int | main (void)
| Main function to call the QSPIPSU Flash example. More...

## Function Documentation

int BulkErase | ( | XQspiPsu * | QspiPsuPtr,
|  | u8 * | WriteBfrPtr
| ) |  |

This functions performs a bulk erase operation when the flash device has a single die.

Works for both Spansion and Micron

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  WritBfrPtr | is the pointer to command+address to be sent

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

Works for both Spansion and Micron

Parameters

  QspiPsuPtr | is a pointer to the QSPIPSU driver component to use.
  WritBfrPtr | is the pointer to command+address to be sent

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, and XQspiPsu_InterruptTransfer().

Referenced by FlashErase().

int DieErase | ( | XQspiPsu * | QspiPsuPtr,
|  | u8 * | WriteBfrPtr
| ) |  |

This functions performs a die erase operation on all the die in the flash device.

This function uses the die erase command for Micron 512Mbit and 1Gbit

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  WritBfrPtr | is the pointer to command+address to be sent

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

This function uses the die erase command for Micron 512Mbit and 1Gbit

Parameters

  QspiPsuPtr | is a pointer to the QSPIPSU driver component to use.
  WritBfrPtr | is the pointer to command+address to be sent

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, GetRealAddr(), and XQspiPsu_InterruptTransfer().

Referenced by FlashErase().

int FlashEnableQuadMode | ( | XQspiPsu * | QspiPsuPtr | ) |

This API enables Quad mode for the flash parts which require to enable quad mode before using Quad commands.

For S25FL-L series flash parts this is required as the default configuration is x1/x2 mode.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.

Returns
  - XST_SUCCESS if successful.
  - XST_FAILURE if it fails.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, GetRealAddr(), and XQspiPsu_InterruptTransfer().

Referenced by QspiPsuInterruptFlashExample(), and QspiPsuPolledFlashExample().

int FlashEnterExit4BAddMode | ( | XQspiPsu * | QspiPsuPtr,
|  | unsigned int | Enable
| ) |  |

This API enters the flash device into 4 bytes addressing mode.

As per the Micron and ISSI spec, before issuing the command to enter into 4 byte addr mode, a write enable command is issued. For Macronix and Winbond flash parts write enable is not required.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Enable | is a either 1 or 0 if 1 then enters 4 byte if 0 exits.

Returns
  - XST_SUCCESS if successful.
  - XST_FAILURE if it fails.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, GetRealAddr(), and XQspiPsu_InterruptTransfer().

Referenced by QspiPsuInterruptFlashExample(), QspiPsuPolledFlashExample(), and QspiPsuWriteProtectFlashExample().

int FlashErase | ( | XQspiPsu * | QspiPsuPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 * | WriteBfrPtr
| ) |  |

This function erases the sectors in the serial Flash connected to the QSPIPSU interface.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Pointer | to the write buffer (which is to be transmitted)

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References BulkErase(), XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, DieErase(), GetRealAddr(), XQspiPsu_InterruptTransfer(), and XQspiPsu_SelectFlash().

Referenced by QspiPsuInterruptFlashExample(), QspiPsuPolledFlashExample(), and QspiPsuWriteProtectFlashExample().

int FlashRead | ( | XQspiPsu * | QspiPsuPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 | Command,
|  | u8 * | WriteBfrPtr,
|  | u8 * | ReadBfrPtr
| ) |  |

This function performs a read.

This function performs read.

Default setting is in DMA mode.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Command | is the command used to read data from the flash. Supports normal, fast, dual and quad read commands.
  Pointer | to the write buffer which contains data to be transmitted
  Pointer | to the read buffer to which valid received data should be written

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

DMA is the default setting.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Command | is the command used to read data from the flash. Supports normal, fast, dual and quad read commands.
  Pointer | to the write buffer which contains data to be transmitted
  Pointer | to the read buffer to which valid received data should be written

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, GetRealAddr(), MultiDieRead(), and XQspiPsu_InterruptTransfer().

Referenced by QspiPsuInterruptFlashExample(), QspiPsuPolledFlashExample(), and QspiPsuWriteProtectFlashExample().

int FlashReadID | ( | XQspiPsu * | QspiPsuPtr | ) |

Reads the flash ID and identifies the flash in FCT table.

Parameters

  None. |

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, and XQspiPsu_InterruptTransfer().

Referenced by QspiPsuInterruptFlashExample(), QspiPsuPolledFlashExample(), and QspiPsuWriteProtectFlashExample().

int FlashWrite | ( | XQspiPsu * | QspiPsuPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 | Command,
|  | u8 * | WriteBfrPtr
| ) |  |

This function writes to the serial Flash connected to the QSPIPSU interface.

All the data put into the buffer must be in the same page of the device with page boundaries being on 256 byte boundaries.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address to write data to in the Flash.
  ByteCount | contains the number of bytes to write.
  Command | is the command used to write data to the flash. QSPIPSU device supports only Page Program command to write data to the flash.
  Pointer | to the write buffer (which is to be transmitted)

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

All the data put into the buffer must be in the same page of the device with page boundaries being on 256 byte boundaries.

Parameters

  QspiPsuPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address to write data to in the Flash.
  ByteCount | contains the number of bytes to write.
  Command | is the command used to write data to the flash. QSPIPSU device supports only Page Program command to write data to the flash.
  Pointer | to the write buffer (which is to be transmitted)

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, GetRealAddr(), and XQspiPsu_InterruptTransfer().

Referenced by QspiPsuInterruptFlashExample(), QspiPsuPolledFlashExample(), and QspiPsuWriteProtectFlashExample().

u32 GetRealAddr | ( | XQspiPsu * | QspiPsuPtr,
|  | u32 | Address
| ) |  |

This functions translates the address based on the type of interconnection.

In case of stacked, this function asserts the corresponding slave select.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | which is to be accessed (for erase, write or read)

Returns
  RealAddr is the translated address - for single it is unchanged; for stacked, the lower flash size is subtracted; for parallel the address is divided by 2.

Note
  In addition to get the actual address to work on flash this function also selects the CS and BUS based on the configuration detected.

In case of stacked, this function asserts the corresponding slave select.

Parameters

  QspiPsuPtr | is a pointer to the QSPIPSU driver component to use.
  Address | which is to be accessed (for erase, write or read)

Returns
  RealAddr is the translated address - for single it is unchanged for stacked, the lower flash size is subtracted; for parallel the address is divided by 2.

Note
  In addition to get the actual address to work on flash this function also selects the CS and BUS based on the configuration detected.

In case of stacked, this function asserts the corresponding slave select.

Parameters

  QspiPsuPtr | is a pointer to the QSPIPSU driver component to use.
  Address | which is to be accessed (for erase, write or read)

Returns
  RealAddr is the translated address - for single it is unchanged; for stacked, the lower flash size is subtracted; for parallel the address is divided by 2.

Note
  In addition to get the actual address to work on flash this function also selects the CS and BUS based on the configuration detected.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, and XQspiPsu_SelectFlash().

Referenced by DieErase(), FlashEnableQuadMode(), FlashEnterExit4BAddMode(), FlashErase(), FlashRead(), FlashWrite(), and MultiDieRead().

int main | ( | void |  | ) |

Main function to call the QSPIPSU Flash example.

Parameters

  None |

Returns
  XST_SUCCESS if successful, otherwise XST_FAILURE.

Note
  None

References QspiPsuInterruptFlashExample().

int MultiDieRead | ( | XQspiPsu * | QspiPsuPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 | Command,
|  | u8 * | WriteBfrPtr,
|  | u8 * | ReadBfrPtr
| ) |  |

This function performs a read operation for multi die flash devices.

This functions performs a read operation for multi die flash devices.

Default setting is in DMA mode.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Command | is the command used to read data from the flash. Supports normal, fast, dual and quad read commands.
  Pointer | to the write buffer which contains data to be transmitted
  Pointer | to the read buffer to which valid received data should be written

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

Parameters

  QspiPtr | is a pointer to the QSPIPSU driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Command | is the command used to read data from the flash. Supports normal, fast, dual and quad read commands.
  Pointer | to the write buffer which contains data to be transmitted
  Pointer | to the read buffer to which valid received data should be written.

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, GetRealAddr(), and XQspiPsu_InterruptTransfer().

Referenced by FlashRead().

void QspiPsuHandler | ( | void * | CallBackRef,
|  | u32 | StatusEvent,
|  | unsigned int | ByteCount
| ) |  |

Callback handler.

Parameters

  None. |

Returns
  None

Note
  None.

Referenced by QspiPsuInterruptFlashExample(), and QspiPsuWriteProtectFlashExample().

int QspiPsuInterruptFlashExample | ( | XScuGic * | IntcInstancePtr,
|  | XQspiPsu * | QspiPsuInstancePtr,
|  | u16 | QspiPsuDeviceId,
|  | u16 | QspiPsuIntrId
| ) |  |

The purpose of this function is to illustrate how to use the XQspiPsu device driver in single, parallel and stacked modes using flash devices greater than or equal to 128Mb.

Parameters

  None. |

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XQspiPsu_Config::BaseAddress, XQspiPsu::Config, XQspiPsu_Config::ConnectionMode, FlashEnableQuadMode(), FlashEnterExit4BAddMode(), FlashErase(), FlashRead(), FlashReadID(), FlashWrite(), QspiPsuHandler(), XQspiPsu_CfgInitialize(), XQspiPsu_LookupConfig(), XQspiPsu_SelectFlash(), XQspiPsu_SetClkPrescaler(), XQspiPsu_SetOptions(), and XQspiPsu_SetStatusHandler().

Referenced by main().